import java.io.*;
import java.util.*;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;
import br.usp.pcs.lta.cogroo.entity.Mistake;
import br.usp.pcs.lta.cogroo.grammarchecker.GrammarCheckerBrazilianPortuguese;


public class CorretorGramatical {

  public static void main(String[] args) throws IOException {

    // cria instância do corretor gramatical
    GrammarCheckerBrazilianPortuguese corretorGramatical = new GrammarCheckerBrazilianPortuguese();
    try {
      Scanner entrada = new Scanner(System.in);
      System.out.println("Está pronto");
      while (true) {
        String comando = entrada.nextLine();
        if (comando.equals("-*?terminou?*-")) 
          break;
        FileReader arquivo = new FileReader("/tmp/cogrootexto");  
        BufferedReader leitor = new BufferedReader(arquivo);  
        String texto = "";
        String linha;
        while ((linha = leitor.readLine()) != null) {  
          texto = texto + linha;
          texto = texto + "\n";
        }
        leitor.close();  
        arquivo.close();  
        
        List<Mistake> erros = corretorGramatical.checkText(texto); 
        FileWriter file = new FileWriter("/tmp/cogrooerros", true);
        if (erros.size() > 0) {
          for (Mistake erro : erros) {
            //System.out.println("   Mensagem longa '" + erro.getFullMessage() + "'");
            //System.out.println("   Texto com erro '" + entrada.substring(erro.getStart(), erro.getEnd()) + "'");
            file.write(String.valueOf(erro.getStart()) + "\n");
            file.write(String.valueOf(erro.getEnd()) + "\n");
            file.write("Regra: '" + erro.getRuleIdentifier() + "'\n");
            file.write("Mensagem curta: '" + erro.getShortMessage() + "'\n");
            file.write("*\n");
            for (String sugestao : erro.getSuggestions()) {
              file.write(sugestao + "\n");
            }         
            file.write("**\n");
          }
        }
        file.close();  
        System.out.println("pode seguir");  
      }
      System.out.println("pode seguir"); 
    } 
    catch(Exception e){ 
       e.printStackTrace(); 
    }
  }
}
